unit FigurenmitOpenGL;

interface
uses Kreise,OpenGL;
procedure ErstelleKreis(Radius:Real;PunkteAnzahl:Word);
procedure ErstelleZylinder(Radius:Real;Height:Real;PunkteAnzahl:Word;Gitteransicht:Boolean=false);
procedure ErstelleKugel(Radius:Real;BAnzahl,LAnzahl:Word);
procedure ErstelleKegel(Radius,Height:Real;EckenAnzahl:Word);
procedure ErstelleEinFarbigenKegel(Radius,Height:Real;EckenAnzahl:Word;red,green,blue:Byte;FarbAbnahme:Double);
procedure ErstelleTexturKegel(Radius,Height:Real;EckenAnzahl:Word);
implementation
procedure ErstelleZylinder(Radius:Real;Height:Real;PunkteAnzahl:Word;Gitteransicht:Boolean=false);
var
  PunktNummer:integer;
  w:Real;
begin
 w:=0;
 if Gitteransicht then glbegin(GL_LINE_LOOP) else glbegin(GL_QUADS);
 for PunktNummer :=  0 to PunkteAnzahl do
 begin
   glvertex3f(Radius*cos(w),Radius*sin(w),0);
   glvertex3f(Radius*cos(w),Radius*sin(w),Height);
   w:=(PunktNummer+1)/PunkteAnzahl*2*pi;
   glvertex3f(Radius*cos(w),Radius*sin(w),Height);
   glvertex3f(Radius*cos(w),Radius*sin(w),0);
 end;
 glend;
 if Gitteransicht then glbegin(GL_LINE_LOOP) else glbegin(GL_POLYGON);
 for PunktNummer :=  0 to PunkteAnzahl do
 begin
  w:=(PunktNummer)/PunkteAnzahl*2*pi;
  glvertex3f(Radius*cos(w),Radius*sin(w),0);
 end;
 glend;
 if Gitteransicht then glbegin(GL_LINE_LOOP) else glbegin(GL_POLYGON);
 for PunktNummer :=  0 to PunkteAnzahl do
 begin
  w:=(PunktNummer)/PunkteAnzahl*2*pi;
  glvertex3f(Radius*cos(w),Radius*sin(w),0);
 end;
 glend;


end;

procedure ErstelleKreis(Radius:Real;PunkteAnzahl:Word);
var PunktNummer:integer;
begin
  glbegin(gl_Line_Loop) ;
 for PunktNummer := 0 to PunkteAnzahl do
  glvertex3f( (Radius *sin(Punktnummer/(PunkteAnzahl/(2*pi)))),(Radius *cos(Punktnummer/(PunkteAnzahl/(2*pi)))),0);
  glend;
end;

procedure ErstelleKugel(Radius:Real;BAnzahl,LAnzahl:Word);
var Breiten,Laengen:Integer;
begin
 for Breiten := 0 to BAnzahl-1 do //BAnzahl gehrt hier hin
 begin
  glBegin(GL_QUADS);
  for Laengen :=  0  to LAnzahl-1 do
  begin

   glVertex3f(XvomKugelpunkt(Radius,Laengen,Breiten,LAnzahl,BAnzahl),YvomKugelpunkt(Radius,Laengen,Breiten,LAnzahl,BAnzahl), ZvomKugelpunkt(Radius,Laengen,LAnzahl));

   glVertex3f(XvomKugelpunkt(Radius,Laengen,Breiten+1,LAnzahl,BAnzahl),YvomKugelpunkt(Radius,Laengen,Breiten+1,LAnzahl,BAnzahl), ZvomKugelpunkt(Radius,Laengen,LAnzahl));

   glVertex3f(XvomKugelpunkt(Radius,Laengen+1,Breiten+1,LAnzahl,BAnzahl),YvomKugelpunkt(Radius,Laengen+1,Breiten+1,LAnzahl,BAnzahl), ZvomKugelpunkt(Radius,Laengen+1,LAnzahl));

   glVertex3f(XvomKugelpunkt(Radius,Laengen+1,Breiten,LAnzahl,BAnzahl),YvomKugelpunkt(Radius,Laengen+1,Breiten,LAnzahl,BAnzahl), ZvomKugelpunkt(Radius,Laengen+1,LAnzahl));

  end;
  glEnd();
 end;
end;

procedure ErstelleKegel(Radius,Height:Real;EckenAnzahl:Word);
var Punkt :Integer;
begin
 glBegin(GL_TRIANGLE_FAN);
 glVertex3f(0,0,Height);
 for Punkt := 0 to EckenAnzahl do
 begin
 //glColor4f(0,0,0,1) ;
 glVertex3f(XvomKreispunkt(Radius,Punkt,EckenAnzahl),YvomKreispunkt(Radius,Punkt,EckenAnzahl),0);;
 end;
 glend();
end;

procedure ErstelleTexturKegel(Radius,Height:Real;EckenAnzahl:Word);
var Punkt :Integer;
begin
 glBegin(GL_TRIANGLE_FAN);
 glTexCoord2f(0.5,0.5);
 glVertex3f(0,0,Height);
 for Punkt := 0 to EckenAnzahl do
 begin
 glTexCoord2f(XvomKreispunkt(Radius,Punkt,EckenAnzahl),yvomKreispunkt(Radius,Punkt,EckenAnzahl));
 glVertex3f(XvomKreispunkt(Radius,Punkt,EckenAnzahl),YvomKreispunkt(Radius,Punkt,EckenAnzahl),0);;

 end;
 glend();
end;

procedure ErstelleEinFarbigenKegel(Radius,Height:Real;EckenAnzahl:Word;red,green,blue:Byte;FarbAbnahme:Double);
var Punkt :Integer;
begin

 glColor3f(Red*FarbAbnahme,green*FarbAbnahme,blue*FarbAbnahme) ;
 glBegin(GL_TRIANGLE_FAN);
 glVertex3f(0,0,Height);
 for Punkt := 0 to EckenAnzahl do
 begin
 glColor3f(Red*(1-FarbAbnahme),green*(1-FarbAbnahme),blue*(1-FarbAbnahme)) ;
 glVertex3f(XvomKreispunkt(Radius,Punkt,EckenAnzahl),YvomKreispunkt(Radius,Punkt,EckenAnzahl),0);;
 end;
 glend();
end;


end.
