unit RenderUnit;

interface
procedure Render;//Allgemeiner Render Befehl
procedure glResizeWnd(Width, Height : Integer); //Behandelt Grenvernderung des Fensters
implementation
uses Windows,OpenGL12,GlobaleVariablen,FloriansWinkel,FigurenmitOpenGL;
{------------------------------------------------------------------------------}
{  Allgemeiner Render Befehl                                  }
{------------------------------------------------------------------------------}
procedure AusrichtenaufPunkt(X,Y,Z:Double);
begin
 glrotatef(PunktzuWinkel(X,Y) ,0,0,1);
 glrotatef(90-PunktzuWinkel(Sqrt(X*X+Y*Y),Z ),0,1,0);
 //Zusetzliche 90Drehung an der Y-Achse um X und Z Achse zu vertauschen
end;
procedure Render;
function Q(X:Double):Double;
begin
 result := X*X;
end;
begin
 glPointSize(3);
 glClearColor(0,0,0.2,0);
 glclear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glloadidentity;
 gltranslatef(0,0,-12);

 glcolor3f(0,0,1);

 //Line zwischen den Punkten zeichnen
 glbegin(GL_LINES);
  glvertex3f(PunktA.X,PunktA.Y,PunktA.Z);
  glvertex3f(PunktB.X,PunktB.Y,PunktB.Z);
 glend;

 //Punkt A als Ursprung nehmen
 gltranslatef(PunktA.X,PunktA.Y,PunktA.Z);

 //Punkte zeichnen
 glbegin(GL_POINTS);
  glvertex3f(0,0,0);//Punkt A
  glvertex3f(PunktB.X-PunktA.X,PunktB.Y-PunktA.Y,PunktB.Z-PunktA.Z);//Wirklicher Punkt B
 glend;

 AusrichtenaufPunkt(PunktB.X-PunktA.X,PunktB.Y-PunktA.Y,PunktB.Z-PunktA.Z);

 glcolor3f(0,1,0);

 //Zylinder nun ganz normal gezeichnet werden.
 ErstelleZylinder(1,Sqrt(Q(PunktB.X-PunktA.X)+Q(PunktB.Y-PunktA.Y)+Q(PunktB.Z-PunktA.Z)),20,not Keys[VK_SPACE]);
 //Ermittelter Punkt B
 glbegin(GL_POINTS);
  glvertex3f(0,0,Sqrt(Q(PunktB.X-PunktA.X)+Q(PunktB.Y-PunktA.Y)+Q(PunktB.Z-PunktA.Z)));
 glend;
 glcolor3f(0,0,1);

end;

{------------------------------------------------------------------------------}
{  Behandelt Grenvernderung des Fensters                                    }
{------------------------------------------------------------------------------}
procedure glResizeWnd(Width, Height : Integer);
begin
  if (Height = 0) then Height := 1;
  glViewport(0, 0, Width, Height);    // Setzt den Viewport fr das OpenGL Fenster
  glMatrixMode(GL_PROJECTION);        // Matrix Mode auf Projection setzen
  glLoadIdentity();                   // Reset View
  gluPerspective(45.0, Width/Height, 1.0, 100.0);  // Perspektive den neuen Maen anpassen.
  glMatrixMode(GL_MODELVIEW);         // Zurck zur Modelview Matrix
  glLoadIdentity();                   // Reset View
end;
end.
